diff -Naur WindowMaker-0.92.0-orig/src/dock.c WindowMaker-0.92.0/src/dock.c
--- WindowMaker-0.92.0-orig/src/dock.c	2007-01-10 23:36:31.000000000 +0100
+++ WindowMaker-0.92.0/src/dock.c	2007-01-10 23:45:03.000000000 +0100
@@ -3606,7 +3847,10 @@
 {
     WScreen *scr = dock->screen_ptr;
     int ofs_x=event->xbutton.x, ofs_y=event->xbutton.y;
-    int x, y;
+    Window wins[2];
+    WIcon *icon = aicon->icon;
+    int x = aicon->x_pos, y = aicon->y_pos;
+    int ix, iy, snapped, shad_x = x, shad_y = y;
     XEvent ev;
     int grabbed = 0, swapped = 0, done;
     Pixmap ghost = None;
@@ -3620,14 +3864,37 @@
                      GrabModeAsync, None, None, CurrentTime) !=GrabSuccess) {
         wwarning("pointer grab failed for dock move");
     }
-    y = 0;
-    for (x=0; x<dock->max_icons; x++) {
-        if (dock->icon_array[x]!=NULL &&
-            dock->icon_array[x]->yindex > y)
-            y = dock->icon_array[x]->yindex;
+    if (dock->type == WM_DRAWER) {
+        wins[0] = icon->core->window;
+        wins[1] = scr->dock_shadow;
+        XRestackWindows(dpy, wins, 2);
+        XMoveResizeWindow(dpy, scr->dock_shadow, aicon->x_pos, aicon->y_pos,
+                          ICON_SIZE, ICON_SIZE);
+        if (superfluous) {
+            if (icon->pixmap!=None)
+                ghost = MakeGhostIcon(scr, icon->pixmap);
+            else
+                ghost = MakeGhostIcon(scr, icon->core->window);
+
+            XSetWindowBackgroundPixmap(dpy, scr->dock_shadow, ghost);
+            XClearWindow(dpy, scr->dock_shadow);
+        }
+        XMapWindow(dpy, scr->dock_shadow);
+    } else {
+        WDrawerChain *dc;
+        y = 0;
+        for (x=0; x<dock->max_icons; x++) {
+            if (dock->icon_array[x]!=NULL &&
+                dock->icon_array[x]->yindex > y)
+                y = dock->icon_array[x]->yindex;
+        }
+        for (dc = scr->drawers; dc; dc = dc->next) {
+            if ((dc->adrawer->y_pos - dock->y_pos) / ICON_SIZE > y)
+                y = (dc->adrawer->y_pos - dock->y_pos) / ICON_SIZE;
+        }
+        y++;
+        XResizeWindow(dpy, scr->dock_shadow, ICON_SIZE, ICON_SIZE*y);
     }
-    y++;
-    XResizeWindow(dpy, scr->dock_shadow, ICON_SIZE, ICON_SIZE*y);
 
     done = 0;
     while (!done) {
@@ -3652,13 +3919,15 @@
                 }
                 break;
             }
-            if (dock->type == WM_CLIP) {
+            switch (dock->type) {
+            case WM_CLIP:
                 x = ev.xmotion.x_root - ofs_x;
                 y = ev.xmotion.y_root - ofs_y;
                 wScreenKeepInside(scr, &x, &y, ICON_SIZE, ICON_SIZE);
 
                 moveDock(dock, x, y);
-            } else {
+                break;
+            case WM_DOCK:
                 /* move vertically if pointer is inside the dock*/
                 if ((dock->on_right_side &&
                      ev.xmotion.x_root >= dock->x_pos - ICON_SIZE)
@@ -3721,7 +3990,23 @@
                         }
                     }
                 }
-            }
+                break;
+            case WM_DRAWER:
+            {
+                WDock *real_dock = dock->screen_ptr->dock;
+
+                x = ev.xmotion.x_root - ofs_x;
+                y = ev.xmotion.y_root - ofs_y;
+                snapped = wDockSnapIcon(real_dock, aicon, x, y, &ix, &iy, True);
+                if (snapped) {
+                    shad_x = real_dock->x_pos + ix*wPreferences.icon_size;
+                    shad_y = real_dock->y_pos + iy*wPreferences.icon_size;
+                    XMoveWindow(dpy, scr->dock_shadow, shad_x, shad_y);
+                }
+                moveDock(dock, x, y);
+                break;
+            } /* local block for real_dock in case WM_DRAWER */
+            } /* end of switch (dock->type) */
             break;
 
         case ButtonPress:
@@ -3731,7 +4016,26 @@
             if (ev.xbutton.button != event->xbutton.button)
                 break;
             XUngrabPointer(dpy, CurrentTime);
-            XUnmapWindow(dpy, scr->dock_shadow);
+            if (dock->type == WM_DRAWER) {
+                int i;
+                Window *wins[ dock->icon_count ];
+                WAppIcon *aicon;
+
+                for (i = 0; i < dock->max_icons; i++) {
+                    if ((aicon = dock->icon_array[ i ]) == NULL)
+                        continue;
+                    wins[ aicon->xindex + (dock->on_right_side ? dock->icon_count - 1 : 0) ] = &aicon->icon->core->window;
+                }
+                SlideWindows(wins, dock->icon_count,
+                               (dock->on_right_side ? x - (dock->icon_count - 1) * ICON_SIZE : x),
+                               y,
+                               (dock->on_right_side ? shad_x - (dock->icon_count - 1) * ICON_SIZE : shad_x),
+                               shad_y);
+                XUnmapWindow(dpy, scr->dock_shadow);
+                moveDock(dock, shad_x, shad_y);
+            } else {
+                XUnmapWindow(dpy, scr->dock_shadow);
+            }
             XResizeWindow(dpy, scr->dock_shadow, ICON_SIZE, ICON_SIZE);
             if (dock->type == WM_DOCK) {
                 if (swapped!=0) {
@@ -3758,283 +4062,53 @@
 }
 
 
-
-static void
-handleIconMove(WDock *dock, WAppIcon *aicon, XEvent *event)
+static int
+getClipButton(int px, int py)
 {
-    WScreen *scr = dock->screen_ptr;
-    Window wins[2];
-    WIcon *icon = aicon->icon;
-    WDock *dock2 = NULL, *last_dock = dock, *clip = NULL;
-    int ondock, grabbed = 0, change_dock = 0, collapsed = 0;
-    XEvent ev;
-    int x = aicon->x_pos, y = aicon->y_pos;
-    int ofs_x = event->xbutton.x, ofs_y = event->xbutton.y;
-    int shad_x = x, shad_y = y;
-    int ix = aicon->xindex, iy = aicon->yindex;
-    int tmp;
-    Pixmap ghost = None;
-    Bool docked;
-    int superfluous = wPreferences.superfluous; /* we catch it to avoid problems */
-    int omnipresent = aicon->omnipresent; /* this must be cached!!! */
-    Bool shown_clip_icons = False;
-
-
-    if (wPreferences.flags.noupdates)
-        return;
+    int pt = (CLIP_BUTTON_SIZE+2)*ICON_SIZE/64;
 
-    if (XGrabPointer(dpy, icon->core->window, True, ButtonMotionMask
-                     |ButtonReleaseMask|ButtonPressMask, GrabModeAsync,
-                     GrabModeAsync, None, None, CurrentTime) !=GrabSuccess) {
-#ifdef DEBUG0
-        wwarning("pointer grab failed for icon move");
-#endif
-    }
+    if (px < 0 || py < 0 || px >= ICON_SIZE || py >= ICON_SIZE)
+        return CLIP_IDLE;
 
-    if (!(event->xbutton.state & MOD_MASK))
-        wRaiseFrame(icon->core);
+    if (py <= pt-((int)ICON_SIZE-1-px))
+        return CLIP_FORWARD;
+    else if (px <= pt-((int)ICON_SIZE-1-py))
+        return CLIP_REWIND;
 
-    if (!wPreferences.flags.noclip)
-        clip = scr->workspaces[scr->current_workspace]->clip;
+    return CLIP_IDLE;
+}
 
-    if (dock == scr->dock && !wPreferences.flags.noclip)
-        dock2 = clip;
-    else if (dock != scr->dock && !wPreferences.flags.nodock)
-        dock2 = scr->dock;
-
-    wins[0] = icon->core->window;
-    wins[1] = scr->dock_shadow;
-    XRestackWindows(dpy, wins, 2);
-    XMoveResizeWindow(dpy, scr->dock_shadow, aicon->x_pos, aicon->y_pos,
-                      ICON_SIZE, ICON_SIZE);
-    if (superfluous) {
-        if (icon->pixmap!=None)
-            ghost = MakeGhostIcon(scr, icon->pixmap);
-        else
-            ghost = MakeGhostIcon(scr, icon->core->window);
 
-        XSetWindowBackgroundPixmap(dpy, scr->dock_shadow, ghost);
-        XClearWindow(dpy, scr->dock_shadow);
-    }
-    XMapWindow(dpy, scr->dock_shadow);
+static void
+handleClipChangeWorkspace(WScreen *scr, XEvent *event)
+{
+    XEvent ev;
+    int done, direction, new_ws;
+    int new_dir;
+    WDock *clip = scr->clip_icon->dock;
 
-    ondock = 1;
+    direction = getClipButton(event->xbutton.x, event->xbutton.y);
 
+    clip->lclip_button_pushed = direction==CLIP_REWIND;
+    clip->rclip_button_pushed = direction==CLIP_FORWARD;
 
-    while(1) {
-        XMaskEvent(dpy, PointerMotionMask|ButtonReleaseMask|ButtonPressMask
-                   |ButtonMotionMask|ExposureMask, &ev);
+    wClipIconPaint(scr->clip_icon);
+    done = 0;
+    while(!done) {
+        WMMaskEvent(dpy, ExposureMask|ButtonMotionMask|ButtonReleaseMask
+                    |ButtonPressMask, &ev);
         switch (ev.type) {
         case Expose:
             WMHandleEvent(&ev);
             break;
 
         case MotionNotify:
-            if (!grabbed) {
-                if (abs(ofs_x-ev.xmotion.x)>=MOVE_THRESHOLD
-                    || abs(ofs_y-ev.xmotion.y)>=MOVE_THRESHOLD) {
-                    XChangeActivePointerGrab(dpy, ButtonMotionMask
-                                             |ButtonReleaseMask|ButtonPressMask,
-                                             wCursor[WCUR_MOVE], CurrentTime);
-                    grabbed=1;
-                } else {
-                    break;
-                }
-            }
-
-            if (omnipresent && !shown_clip_icons) {
-                int i;
-                for (i=0; i<scr->workspace_count; i++) {
-                    if (i == scr->current_workspace)
-                        continue;
-                    wDockShowIcons(scr->workspaces[i]->clip);
-                    /* Pb: if dock is collapsed (for instance, because
-                       it auto-collapses), its icons won't be shown. */
-                }
-                shown_clip_icons = True; /* avoid flickering */
-            }
-
-            x = ev.xmotion.x_root - ofs_x;
-            y = ev.xmotion.y_root - ofs_y;
-            tmp = wDockSnapIcon(dock, aicon, x, y, &ix, &iy, True);
-            if (tmp && dock2) {
-                change_dock = 0;
-                if (last_dock != dock && collapsed) {
-                    last_dock->collapsed = 1;
-                    wDockHideIcons(last_dock);
-                    collapsed = 0;
-                }
-                if (!collapsed && (collapsed = dock->collapsed)) {
-                    dock->collapsed = 0;
-                    wDockShowIcons(dock);
-                }
-                if (dock->auto_raise_lower)
-                    wDockRaise(dock);
-                last_dock = dock;
-            } else if (dock2) {
-                tmp = wDockSnapIcon(dock2, aicon, x, y, &ix, &iy, False);
-                if (tmp) {
-                    change_dock = 1;
-                    if (last_dock != dock2 && collapsed) {
-                        last_dock->collapsed = 1;
-                        wDockHideIcons(last_dock);
-                        collapsed = 0;
-                    }
-                    if (!collapsed && (collapsed = dock2->collapsed)) {
-                        dock2->collapsed = 0;
-                        wDockShowIcons(dock2);
-                    }
-                    if (dock2->auto_raise_lower)
-                        wDockRaise(dock2);
-                    last_dock = dock2;
-                }
-            }
-            if (aicon->launching
-                || aicon->lock
-                || (aicon->running && !(ev.xmotion.state & MOD_MASK))
-                || (!aicon->running && tmp)) {
-                shad_x = last_dock->x_pos + ix*wPreferences.icon_size;
-                shad_y = last_dock->y_pos + iy*wPreferences.icon_size;
-
-                XMoveWindow(dpy, scr->dock_shadow, shad_x, shad_y);
-
-                if (!ondock) {
-                    XMapWindow(dpy, scr->dock_shadow);
-                }
-                ondock = 1;
-            } else {
-                if (ondock) {
-                    XUnmapWindow(dpy, scr->dock_shadow);
-                }
-                ondock = 0;
-            }
-            XMoveWindow(dpy, icon->core->window, x, y);
-            break;
-
-        case ButtonPress:
-            break;
-
-        case ButtonRelease:
-            if (ev.xbutton.button != event->xbutton.button)
-                break;
-            XUngrabPointer(dpy, CurrentTime);
-            if (ondock) {
-                SlideWindow(icon->core->window, x, y, shad_x, shad_y);
-                XUnmapWindow(dpy, scr->dock_shadow);
-                if (!change_dock) {
-                    reattachIcon(dock, aicon, ix, iy);
-                    if (clip && dock!=clip && clip->auto_raise_lower)
-                        wDockLower(clip);
-                } else {
-                    docked = moveIconBetweenDocks(dock, dock2, aicon, ix, iy);
-                    if (!docked) {
-                        /* Slide it back if dock rejected it */
-                        SlideWindow(icon->core->window, x, y, aicon->x_pos,
-                                    aicon->y_pos);
-                        reattachIcon(dock, aicon, aicon->xindex,aicon->yindex);
-                    }
-                    if (last_dock->type==WM_CLIP && last_dock->auto_collapse) {
-                        collapsed = 0;
-                    }
-                }
-            } else {
-                aicon->x_pos = x;
-                aicon->y_pos = y;
-                if (superfluous) {
-                    if (!aicon->running && !wPreferences.no_animations) {
-                        /* We need to deselect it, even if is deselected in
-                         * wDockDetach(), because else DoKaboom() will fail.
-                         */
-                        if (aicon->icon->selected)
-                            wIconSelect(aicon->icon);
-
-                        wSoundPlay(WSOUND_KABOOM);
-                        DoKaboom(scr,aicon->icon->core->window, x, y);
-                    } else {
-                        wSoundPlay(WSOUND_UNDOCK);
-                    }
-                } else {
-                    wSoundPlay(WSOUND_UNDOCK);
-                }
-                if (clip && clip->auto_raise_lower)
-                    wDockLower(clip);
-                wDockDetach(dock, aicon);
-            }
-            if (collapsed) {
-                last_dock->collapsed = 1;
-                wDockHideIcons(last_dock);
-                collapsed = 0;
-            }
-            if (superfluous) {
-                if (ghost!=None)
-                    XFreePixmap(dpy, ghost);
-                XSetWindowBackground(dpy, scr->dock_shadow, scr->white_pixel);
-            }
-            if (shown_clip_icons) {
-                int i;
-                for (i=0; i<scr->workspace_count; i++) {
-                    if (i == scr->current_workspace)
-                        continue;
-                    wDockHideIcons(scr->workspaces[i]->clip);
-                }
-            }
-
-#ifdef DEBUG
-            puts("End icon move");
-#endif
-            return;
-        }
-    }
-}
-
-
-static int
-getClipButton(int px, int py)
-{
-    int pt = (CLIP_BUTTON_SIZE+2)*ICON_SIZE/64;
-
-    if (px < 0 || py < 0 || px >= ICON_SIZE || py >= ICON_SIZE)
-        return CLIP_IDLE;
-
-    if (py <= pt-((int)ICON_SIZE-1-px))
-        return CLIP_FORWARD;
-    else if (px <= pt-((int)ICON_SIZE-1-py))
-        return CLIP_REWIND;
-
-    return CLIP_IDLE;
-}
-
-
-static void
-handleClipChangeWorkspace(WScreen *scr, XEvent *event)
-{
-    XEvent ev;
-    int done, direction, new_ws;
-    int new_dir;
-    WDock *clip = scr->clip_icon->dock;
-
-    direction = getClipButton(event->xbutton.x, event->xbutton.y);
-
-    clip->lclip_button_pushed = direction==CLIP_REWIND;
-    clip->rclip_button_pushed = direction==CLIP_FORWARD;
-
-    wClipIconPaint(scr->clip_icon);
-    done = 0;
-    while(!done) {
-        WMMaskEvent(dpy, ExposureMask|ButtonMotionMask|ButtonReleaseMask
-                    |ButtonPressMask, &ev);
-        switch (ev.type) {
-        case Expose:
-            WMHandleEvent(&ev);
-            break;
-
-        case MotionNotify:
-            new_dir = getClipButton(ev.xmotion.x, ev.xmotion.y);
-            if (new_dir != direction) {
-                direction = new_dir;
-                clip->lclip_button_pushed = direction==CLIP_REWIND;
-                clip->rclip_button_pushed = direction==CLIP_FORWARD;
-                wClipIconPaint(scr->clip_icon);
+            new_dir = getClipButton(ev.xmotion.x, ev.xmotion.y);
+            if (new_dir != direction) {
+                direction = new_dir;
+                clip->lclip_button_pushed = direction==CLIP_REWIND;
+                clip->rclip_button_pushed = direction==CLIP_FORWARD;
+                wClipIconPaint(scr->clip_icon);
             }
             break;
 
@@ -4122,7 +4196,7 @@
             else
                 handleDockMove(dock, aicon, event);
         } else
-            handleIconMove(dock, aicon, event);
+            wHandleAppIconMove(aicon, event);
 
     } else if (event->xbutton.button==Button2 && dock->type==WM_CLIP &&
                aicon==scr->clip_icon) {
@@ -4229,7 +4303,7 @@
     scr = btn->icon->core->screen_ptr;
     dock = btn->dock;
 
-    if (!dock || dock->type!=WM_CLIP)
+    if (!dock || (dock->type != WM_CLIP && dock->type != WM_DRAWER))
         return;
 
     /* The auto raise/lower code */
@@ -4254,12 +4328,14 @@
                                                     (void *)dock);
     }
 
-    if (btn->xindex == 0 && btn->yindex == 0)
-        showClipBalloon(dock, dock->screen_ptr->current_workspace);
-    else {
-        if (dock->screen_ptr->flags.clip_balloon_mapped) {
-            XUnmapWindow(dpy, dock->screen_ptr->clip_balloon);
-            dock->screen_ptr->flags.clip_balloon_mapped = 0;
+    if (dock->type == WM_CLIP) {
+        if (btn->xindex == 0 && btn->yindex == 0)
+            showClipBalloon(dock, dock->screen_ptr->current_workspace);
+        else {
+            if (dock->screen_ptr->flags.clip_balloon_mapped) {
+                XUnmapWindow(dpy, dock->screen_ptr->clip_balloon);
+                dock->screen_ptr->flags.clip_balloon_mapped = 0;
+            }
         }
     }
 }
@@ -4271,16 +4347,15 @@
     XEvent event;
     WObjDescriptor *desc = NULL;
 
-    if (!dock || dock->type!=WM_CLIP)
+    if (!dock || (dock->type != WM_CLIP && dock->type != WM_DRAWER))
         return;
 
     if (XCheckTypedEvent(dpy, EnterNotify, &event)!=False) {
         if (XFindContext(dpy, event.xcrossing.window, wWinContext,
                          (XPointer *)&desc)!=XCNOENT
             && desc && desc->parent_type==WCLASS_DOCK_ICON
-            && ((WAppIcon*)desc->parent)->dock
-            && ((WAppIcon*)desc->parent)->dock->type==WM_CLIP) {
-            /* We didn't left the Clip yet */
+            && ((WAppIcon*)desc->parent)->dock == dock) {
+            /* We haven't left the Clip/Drawer yet */
             XPutBackEvent(dpy, &event);
             return;
         }
@@ -4332,7 +4407,7 @@
 {
     WDock *dock = (WDock *)cdata;
 
-    if (dock->type!=WM_CLIP)
+    if (dock->type != WM_CLIP && dock->type != WM_DRAWER)
         return;
 
     if (dock->auto_collapse) {
@@ -4348,7 +4423,7 @@
 {
     WDock *dock = (WDock *)cdata;
 
-    if (dock->type!=WM_CLIP)
+    if (dock->type != WM_CLIP && dock->type != WM_DRAWER)
         return;
 
     if (dock->auto_collapse) {
@@ -4364,7 +4439,7 @@
 {
     WDock *dock = (WDock *)cdata;
 
-    if (dock->type!=WM_CLIP)
+    if (dock->type != WM_CLIP && dock->type != WM_DRAWER)
         return;
 
     if (dock->auto_raise_lower)
@@ -4379,7 +4454,7 @@
 {
     WDock *dock = (WDock *)cdata;
 
-    if (dock->type!=WM_CLIP)
+    if (dock->type != WM_CLIP && dock->type != WM_DRAWER)
         return;
 
     if (dock->auto_raise_lower)
